commit c33264393a1c70c92a1fccdfa0640988da26351e
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Thu Jan 22 19:30:43 2026 +0000

    Debug: use defined-width type for bitmap

diff --git a/src/exim_monitor/em_main.c b/src/exim_monitor/em_main.c
index 143de870d..d85cefdba 100644
--- a/src/exim_monitor/em_main.c
+++ b/src/exim_monitor/em_main.c
@@ -168,7 +168,7 @@ Returns:    nothing
 */
 
 void
-log_write(unsigned int selector, int flags, const char *format, ...)
+log_write(bitmask_word_t selector, int flags, const char *format, ...)
 {
 va_list ap;
 va_start(ap, format);
@@ -179,7 +179,7 @@ va_end(ap);
 
 
 void
-log_write_die(unsigned int selector, int flags, const char *format, ...)
+log_write_die(bitmask_word_t selector, int flags, const char *format, ...)
 {
 va_list ap;
 va_start(ap, format);
diff --git a/src/src/buildconfig.c b/src/src/buildconfig.c
index 081d1041b..b365643bb 100644
--- a/src/src/buildconfig.c
+++ b/src/src/buildconfig.c
@@ -207,9 +207,6 @@ else
   fprintf(new, "#define SSIZE_T_FMT  \"%%d\"\n");
 #endif
 
-fprintf(new, "#define EXIM_ULONG_BITS	%u\n",
-		sizeof(unsigned long) == 8 ? 64 : 32);
-
 /* Now search the makefile for certain settings */
 
 if (!(base = fopen("Makefile", "rb")))
diff --git a/src/src/child.c b/src/src/child.c
index 05f87d856..de08095af 100644
--- a/src/src/child.c
+++ b/src/src/child.c
@@ -107,7 +107,7 @@ if (!minimal)
     {
     if (debug_selector != 0)
       {
-      argv[n++] = string_sprintf("-d=0x%lx", debug_selector);
+      argv[n++] = string_sprintf("-d=0x" PR_EXIM_BITMASK, debug_selector);
       if (debug_fd > 2)
 	{
 	int flags = fcntl(debug_fd, F_GETFD);
diff --git a/src/src/config.h.defaults b/src/src/config.h.defaults
index ba9f50b01..e99b10c16 100644
--- a/src/src/config.h.defaults
+++ b/src/src/config.h.defaults
@@ -247,4 +247,11 @@ for EXIM_ARITH_MAX and _MIN in OS/oh.h-FOO */
 #define SC_EXIM_ARITH "%" SCNi64		/* scanf incl. 0x prefix */
 #define SC_EXIM_DEC   "%" SCNd64		/* scanf decimal */
 
+/* Word size for debug and logging channel bitmaps.
+Change as above (but expect debugging to become odd). */
+#define bitmask_word_t		uint64_t
+#define EXIM_BITMAP_WORD_BITS	64
+#define PR_EXIM_BITMASK		"%" PRIx64
+#define SC_EXIM_BITMASK		"%" SCNx64
+
 /* End of config.h.defaults */
diff --git a/src/src/daemon.c b/src/src/daemon.c
index 607913f6c..bce9bb9f4 100644
--- a/src/src/daemon.c
+++ b/src/src/daemon.c
@@ -188,7 +188,7 @@ pid_t pid;
 union sockaddr_46 interface_sockaddr;
 EXIM_SOCKLEN_T ifsize = sizeof(interface_sockaddr);
 int max_for_this_host = 0;
-unsigned long save_log_selector = *log_selector;
+bitmask_word_t save_log_selector = *log_selector;
 gstring * whofrom;
 
 rmark reset_point = store_mark();
@@ -365,7 +365,7 @@ if (pid == 0)
   {
   int queue_only_reason = 0;
   int old_pool = store_pool;
-  unsigned long save_debug_selector = debug_selector;
+  bitmask_word_t save_debug_selector = debug_selector;
   BOOL local_queue_only,  session_local_queue_only;
 #ifdef SA_NOCLDWAIT
   struct sigaction act;
diff --git a/src/src/environment.c b/src/src/environment.c
index 4b8041f9f..58af6b6c3 100644
--- a/src/src/environment.c
+++ b/src/src/environment.c
@@ -42,7 +42,7 @@ if (!keep_environment || !*keep_environment)
 else if (Ustrcmp(keep_environment, "*") != 0)
   {
   rmark reset_point = store_mark();
-  unsigned long deb = debug_selector;
+  bitmask_word_t deb = debug_selector;
   BOOL hc = host_checking;
   debug_selector = 0;			/* quieten this clearout */
   host_checking = FALSE;
diff --git a/src/src/exim.c b/src/src/exim.c
index 489aa3bd6..5a756cc4d 100644
--- a/src/src/exim.c
+++ b/src/src/exim.c
@@ -3982,8 +3982,9 @@ if (debug_selector != 0)
   testharness_pause_ms(100);   /* lets caller finish */
   if (debug_selector != D_v)    /* -v only doesn't show this */
     {
-    debug_printf("Exim version %s uid=%ld gid=%ld pid=%d D=%x\n",
-      version_string, (long int)real_uid, (long int)real_gid, (int)getpid(),
+    debug_printf("Exim version %s uid=%ld gid=%ld pid=" PID_T_FMT
+      " D=0x" PR_EXIM_BITMASK "\n",
+      version_string, (long int)real_uid, (long int)real_gid, getpid(),
       debug_selector);
     if (!version_printed)
       show_whats_supported(FALSE);
@@ -4290,7 +4291,7 @@ DEBUG(D_any)
   debug_printf("configuration file is %s\n", config_main_filename);
   debug_printf("log selectors =");
   for (int i = 0; i < log_selector_size; i++)
-    debug_printf(" %08x", log_selector[i]);
+    debug_printf(" 0x" PR_EXIM_BITMASK, log_selector[i]);
   debug_printf("\n");
   }
 
diff --git a/src/src/exim_dbmbuild.c b/src/src/exim_dbmbuild.c
index c6c884125..1ffedfd95 100644
--- a/src/src/exim_dbmbuild.c
+++ b/src/src/exim_dbmbuild.c
@@ -69,7 +69,7 @@ string_format_trc(uschar * buf, int len, const uschar * func, unsigned line,
   const char * fmt, ...)
 { return FALSE; }
 void
-log_write(unsigned int selector, int flags, const char *format, ...)
+log_write(bitmask_word_t selector, int flags, const char *format, ...)
 { }
 const uschar * parse_find_address_end_gen(const uschar * s, BOOL b)
 {return NULL; }
@@ -77,7 +77,7 @@ const uschar * parse_find_address_end_gen(const uschar * s, BOOL b)
 
 
 struct global_flags	f;
-unsigned long		log_selector[1];
+bitmask_word_t		log_selector[1];
 uschar *		queue_name;
 BOOL			split_spool_directory;
 
@@ -98,7 +98,7 @@ const uschar *hex_digits = CUS"0123456789abcdef";
 *   Debug output   *
 *******************/
 
-unsigned long debug_selector = 0;	/* set -1 for debugging */
+bitmask_word_t debug_selector = 0;	/* set -1 for debugging */
 
 void
 debug_printf(const char * fmt, ...)
diff --git a/src/src/exim_dbutil.c b/src/src/exim_dbutil.c
index 2955861fa..04b3023b7 100644
--- a/src/src/exim_dbutil.c
+++ b/src/src/exim_dbutil.c
@@ -65,7 +65,7 @@ const uschar * parse_find_address_end_gen(const uschar * s, BOOL b)
 {return NULL; }
 
 struct global_flags	f;
-unsigned long		log_selector[1];
+bitmask_word_t		log_selector[1];
 uschar *		queue_name;
 BOOL			split_spool_directory;
 
@@ -113,7 +113,7 @@ exit(EXIT_FAILURE);
 *   Debug output   *
 *******************/
 
-unsigned long debug_selector = 0;	/* set -1 for debugging */
+bitmask_word_t debug_selector = 0;	/* set -1 for debugging */
 
 void
 debug_printf(const char * fmt, ...)
@@ -195,7 +195,7 @@ Returns:    nothing
 */
 
 void
-log_write(unsigned int selector, int flags, const char *format, ...)
+log_write(bitmask_word_t selector, int flags, const char *format, ...)
 {
 va_list ap;
 va_start(ap, format);
@@ -205,7 +205,7 @@ va_end(ap);
 }
 
 void
-log_write_die(unsigned int selector, int flags, const char *format, ...)
+log_write_die(bitmask_word_t selector, int flags, const char *format, ...)
 {
 va_list ap;
 va_start(ap, format);
diff --git a/src/src/expand.c b/src/src/expand.c
index 3c68ab2e9..5e46f7cde 100644
--- a/src/src/expand.c
+++ b/src/src/expand.c
@@ -9135,7 +9135,7 @@ for (int i = 1; i < argc; i++)
     argv[i]++;
     }
   if (isdigit(argv[i][0]))
-    debug_selector = Ustrtol(argv[i], NULL, 0);
+    debug_selector = Ustrtoul(argv[i], NULL, 0);
   else
     if (Ustrspn(argv[i], "abcdefghijklmnopqrtsuvwxyz0123456789-.:/") ==
         Ustrlen(argv[i]))
diff --git a/src/src/functions.h b/src/src/functions.h
index 677972e01..0981f126b 100644
--- a/src/src/functions.h
+++ b/src/src/functions.h
@@ -302,7 +302,7 @@ extern const uschar *local_part_quote(const uschar *);
 extern void    log_close_all(void);
 extern int     log_open_as_exim(const uschar * const);
 extern gstring *log_portnum(gstring *, int);
-extern void    log_write_die(unsigned, int, const char * format, ...)
+extern void    log_write_die(bitmask_word_t, int, const char * format, ...)
 		PRINTF_FUNCTION(3,4) NORETURN;
 
 extern const lookup_info * lookup_with_acq_num(unsigned);
diff --git a/src/src/globals.c b/src/src/globals.c
index 142cdde5e..58dc8bffd 100644
--- a/src/src/globals.c
+++ b/src/src/globals.c
@@ -702,7 +702,7 @@ int      debug_options_count	= nelem(debug_options);
 uschar   debuglog_name[LOG_NAME_SIZE] = {0};
 unsigned debug_pretrigger_bsize	= 0;
 uschar * debug_pretrigger_buf	= NULL;
-unsigned long debug_selector	= 0;
+bitmask_word_t debug_selector	= 0;
 BOOL	 debug_startup		= FALSE;
 
 int     delay_warning[DELAY_WARNING_SIZE] = { DELAY_WARNING_SIZE, 1, 24*60*60 };
@@ -1017,7 +1017,7 @@ int     log_options_count      = nelem(log_options);
 
 const uschar *log_ports	       = NULL;
 int     log_reject_target      = 0;
-unsigned long log_selector[log_selector_size]; /* initialized in main() */
+bitmask_word_t log_selector[log_selector_size]; /* initialized in main() */
 uschar *log_selector_string    = NULL;
 FILE   *log_stderr             = NULL;
 uschar *login_sender_address   = NULL;
diff --git a/src/src/globals.h b/src/src/globals.h
index 5402fb59e..dca2d0b17 100644
--- a/src/src/globals.h
+++ b/src/src/globals.h
@@ -673,7 +673,7 @@ extern int     log_notall[];           /* Log options excluded from +all */
 extern bit_table log_options[];        /* Table of options */
 extern int     log_options_count;      /* Size of table */
 extern int     log_reject_target;      /* Target log for ACL rejections */
-extern unsigned long log_selector[];   /* Bit map of logging options */
+extern bitmask_word_t log_selector[];  /* Bit map of logging options */
 extern uschar *log_selector_string;    /* As supplied in the config */
 extern FILE   *log_stderr;             /* Copy of stderr for log use, or NULL */
 extern BOOL    log_timezone;           /* TRUE to include the timezone in log lines */
diff --git a/src/src/local_scan.h b/src/src/local_scan.h
index 6e63672eb..ad2601c38 100644
--- a/src/src/local_scan.h
+++ b/src/src/local_scan.h
@@ -29,6 +29,7 @@ store.c
 settings, and the store functions. */
 
 #include <stdarg.h>
+#include <stdint.h>
 #include <sys/types.h>
 #include "config.h"
 #include "mytypes.h"
@@ -165,7 +166,7 @@ typedef struct recipient_item {
 
 /* Global variables that are documented as visible in the function. */
 
-extern unsigned long debug_selector;   /* Debugging bits */
+extern bitmask_word_t debug_selector;   /* Debugging bits */
 
 extern int     body_linecount;         /* Line count in body */
 extern int     body_zerocount;         /* Binary zero count in body */
@@ -211,7 +212,7 @@ extern void    header_add_at_position(BOOL, uschar *, BOOL, int, const char *, .
 extern void    header_remove(int, const uschar *);
 extern BOOL    header_testname(const header_line *, const uschar *, int, BOOL);
 extern BOOL    header_testname_incomplete(const header_line *, const uschar *, int, BOOL);
-extern void    log_write(unsigned int, int, const char *format, ...) PRINTF_FUNCTION(3,4);
+extern void    log_write(bitmask_word_t, int, const char *format, ...) PRINTF_FUNCTION(3,4);
 extern int     lss_b64decode(uschar *, uschar **);
 extern uschar *lss_b64encode(uschar *, int);
 extern int     lss_match_domain(uschar *, uschar *);
diff --git a/src/src/log.c b/src/src/log.c
index 39ff04378..46d8873da 100644
--- a/src/src/log.c
+++ b/src/src/log.c
@@ -843,7 +843,7 @@ Returns:    nothing
 */
 
 static void
-log_vwrite(unsigned int selector, int flags, const char * format, va_list ap)
+log_vwrite(bitmask_word_t selector, int flags, const char * format, va_list ap)
 {
 int paniclogfd;
 ssize_t written_len;
@@ -1307,7 +1307,7 @@ if (flags & LOG_PANIC)
 /* The public interface */
 
 void
-log_write(unsigned int selector, int flags, const char * format, ...)
+log_write(bitmask_word_t selector, int flags, const char * format, ...)
 {
 va_list ap;
 va_start(ap, format);
@@ -1320,7 +1320,7 @@ We have this as a wrapper so that we can mark it as never returning,
 for the benefit of static analysers. */
 
 void
-log_write_die(unsigned int selector, int flags, const char * format, ...)
+log_write_die(bitmask_word_t selector, int flags, const char * format, ...)
 {
 va_list ap;
 va_start(ap, format);
@@ -1361,14 +1361,14 @@ Arguments:
 */
 
 void
-bits_clear(unsigned long * selector, size_t selsize, int * bits)
+bits_clear(bitmask_word_t * selector, size_t selsize, int * bits)
 {
 for(; *bits != -1; ++bits)
   BIT_CLEAR(selector, selsize, *bits);
 }
 
 void
-bits_set(unsigned long * selector, size_t selsize, int * bits)
+bits_set(bitmask_word_t * selector, size_t selsize, int * bits)
 {
 for(; *bits != -1; ++bits)
   BIT_SET(selector, selsize, *bits);
@@ -1409,7 +1409,7 @@ Returns:         nothing on success - bomb out on failure
 */
 
 void
-decode_bits(unsigned long * selector, size_t selsize, int * notall,
+decode_bits(bitmask_word_t * selector, size_t selsize, int * notall,
   const uschar * string, bit_table * options, int count, uschar * which,
   int flags)
 {
@@ -1419,12 +1419,14 @@ if (!string) return;
 
 if (*string == '=')
   {
-  char *end;    /* Not uschar */
+  int n;
   memset(selector, 0, sizeof(*selector)*selsize);
-  *selector = strtoul(CCS string+1, &end, 0);
-  if (!*end) return;
-  errmsg = string_sprintf("malformed numeric %s_selector setting: %s", which,
-    string);
+  if (  sscanf(CCS string+1, SC_EXIM_BITMASK "%n", selector, &n) == 1
+     && !string[1+n])
+    return;
+
+  errmsg = string_sprintf("malformed numeric %s_selector setting: %q (n %d, fmt %q)", which,
+    string, n, SC_EXIM_BITMASK);
   goto ERROR_RETURN;
   }
 
@@ -1487,7 +1489,7 @@ else for(;;)
   if (start >= end)
     {
     errmsg = string_sprintf("unknown %s_selector setting: %c%.*s", which,
-      adding? '+' : '-', len, s);
+      adding ? '+' : '-', len, s);
     goto ERROR_RETURN;
     }
   }    /* Loop for selector names */
diff --git a/src/src/macros.h b/src/src/macros.h
index 8ab066fac..ea5ca9277 100644
--- a/src/src/macros.h
+++ b/src/src/macros.h
@@ -329,10 +329,10 @@ for having to swallow the rest of an SMTP message is whether the value is
 
 /* Assume words are at least 32 bits wide. Tiny waste of space on 64 bit
 platforms, but this ensures bit vectors always work the same way. */
-#ifdef EXIM_ULONG_BITS
-  #define BITWORDSIZE EXIM_ULONG_BITS
+#ifdef EXIM_BITMAP_WORD_BITS
+# define BITWORDSIZE EXIM_BITMAP_WORD_BITS
 #else
-  #define BITWORDSIZE 64
+# define BITWORDSIZE 64
 #endif
 
 /* This macro is for single-word bit vectors: the debug selector,
@@ -410,7 +410,7 @@ enum {
   DEBUG_BIT(transport),
   DEBUG_BIT(uid),
   DEBUG_BIT(verify),		/* 31 */
-#if EXIM_ULONG_BITS > 32
+#if BITWORDSIZE > 32
   DEBUG_BIT(macro),		/* 33 */
   DEBUG_BIT(regex),
 #else
diff --git a/src/src/spool_in.c b/src/src/spool_in.c
index 35fa5089b..9231a302e 100644
--- a/src/src/spool_in.c
+++ b/src/src/spool_in.c
@@ -620,7 +620,7 @@ for (;;)
       dsn_envid = string_copy_taint(var + 10, proto_mem);
 #ifndef COMPILE_UTILITY
     else if (Ustrncmp(p, "ebug_selector ", 14) == 0)
-      debug_selector = strtoul(CS var + 15, NULL, 0);
+      sscanf(CS var + 15, SC_EXIM_BITMASK, &debug_selector);
     else if (Ustrncmp(p, "ebuglog_name ", 13) == 0)
       debug_logging_from_spool(var + 14);
 #endif
diff --git a/src/src/spool_out.c b/src/src/spool_out.c
index 243db106d..016f7cdd4 100644
--- a/src/src/spool_out.c
+++ b/src/src/spool_out.c
@@ -232,7 +232,7 @@ tree_walk(acl_var_m, &acl_var_write, fp);
 
 if (*debuglog_name)
   {
-  fprintf(fp, "-debug_selector 0x%lx\n", debug_selector);
+  fprintf(fp, "-debug_selector 0x" PR_EXIM_BITMASK "\n", debug_selector);
   fprintf(fp, "-debuglog_name %s\n", debuglog_name);
   }
 

